CBC_CTS_Decryption Class Reference

CBC-CTS block cipher mode of operation decryption operation. More...

Inheritance diagram for CBC_CTS_Decryption:

## Public Member Functions

unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt the last block of data. More...
Public Member Functions inherited from CBC_Decryption
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt an array of bytes. More...
Public Member Functions inherited from CBC_ModeBase
IV_Requirement | IVRequirement () const
| Minimal requirement for secure IVs. More...
bool | RequireAlignedInput () const
Public Member Functions inherited from BlockOrientedCipherModeBase
void | UncheckedSetKey (const byte *key, unsigned int length, const NameValuePairs &params)
| Sets the key for this object without performing parameter validation. More...
unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher. More...
bool | IsRandomAccess () const
| Determines whether the cipher supports random access. More...
bool | IsSelfInverting () const
| Determines whether the cipher is self-inverting. More...
bool | IsForwardTransformation () const
| Determines if the cipher is being operated in its forward direction. More...
void | Resynchronize (const byte *iv, int length=-1)
| Resynchronize with an IV. More...
Public Member Functions inherited from CipherModeBase
size_t | MinKeyLength () const
| Returns smallest valid key length in bytes.
size_t | MaxKeyLength () const
| Returns largest valid key length in bytes.
size_t | DefaultKeyLength () const
| Returns default (recommended) key length in bytes.
size_t | GetValidKeyLength (size_t n) const
bool | IsValidKeyLength (size_t n) const
| Returns whether keylength is a valid key length. More...
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance. More...
unsigned int | IVSize () const
| Returns length of the IV accepted by this object. More...
void | SetCipher (BlockCipher &cipher)
void | SetCipherWithIV (BlockCipher &cipher, const byte *iv, int feedbackSize=0)
Public Member Functions inherited from SimpleKeyingInterface
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object. More...
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object. More...
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object. More...
bool | IsResynchronizable () const
| Determines if the object can be resynchronized. More...
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs. More...
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs. More...
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs returns whether the object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV), false otherwise.
unsigned int | DefaultIVLength () const
| Provides the default size of an IV. More...
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV. More...
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV. More...
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message. More...
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object. More...
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher. More...
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size. More...
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes. More...
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes. More...
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte. More...
virtual void | Seek (lword pos)
| Seek to an absolute position. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...

## Additional Inherited Members

Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...
Static Public Member Functions inherited from CBC_ModeBase
static const char * | StaticAlgorithmName ()

## Detailed Description

CBC-CTS block cipher mode of operation decryption operation.

Definition at line 286 of file modes.h.

## Member Function Documentation

## ProcessLastBlock()

void CBC_CTS_Decryption::ProcessLastBlock | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length
| ) |  |

virtual

Encrypt or decrypt the last block of data.

Parameters

  outString | the output byte buffer
  inString | the input byte buffer
  length | the size of the input and output byte buffers, in bytes ProcessLastBlock is used when the last block of data is special. Currently the only use of this function is CBC-CTS mode.

Reimplemented from StreamTransformation.

Definition at line 244 of file modes.cpp.

The documentation for this class was generated from the following files:

- modes.h
- modes.cpp